;*--------------------------------------------------------------------*;
;*                            S U N E T                               *;
;*--------------------------------------------------------------------*;
code      segment para 'CODE'     ;Definim segment de CODE

          org 100h                ;incepe la adresa 100h, dupa PSP
          assume cs:code, ds:code, es:code, ss:code

sunet  proc near

;-- afisare mesaj -------------------------------------------
          mov  ah,9               ;functia ptr afisare sir
          mov  dx,offset mes_in   ;offset-ul adresei mesaj
          int  21h                ;Apelare intrerupere DOS

;-- generare gama ---------------------------------------------
          xor  bl,bl         ;incep cu Do din octava III
          mov  dl,9          ;durata notei 0.5 sec (9*1/18s=0.5)
nextone:  call play_nota     ;generare  nota
          inc  bl            ;Nota urmatoare
          cmp  bl,12         ;S-au generat toate notele din octava ?
          jne  nextone       ;NU --> generez urmatoarea nota

;-- mesaj de sfirsit -------------------------------------------
          mov  ah,9               
          mov  dx,offset mes_out            
          int  21h                          
          mov  ax,4C00h              ;Terminare program prin apelul unei
          int  21h                   ;functii DOS 
sunet     endp

;== Datele programului principal =====================================

mes_in     db 0dh,0ah,"Generez notele din octava a patra" ,0dh,0ah,"$"
mes_out    db 0dh,0ah,"Gata",0dh,0ah,"$"

;-- PLAY_NOTA: Generez nota ------------------------------------------
;-- Intrare  : BL = Numarul notei raportat la Do octava IV
;--            DL = Durata notei in multiplii de 1/18 de secunda
;-- Iesire   : -
;-- Registre : AX, CX, ES si FLAGS se modifica

play_nota proc near
          push dx             ;Salvez DX si BX pe stiva
          push bx
;-- Redirectez intreruperea timer pe rutina utilizator 
          push dx             ;Salvez DX et BX pe stiva
          push bx
          mov  ax,351ch       ;Citesc adresa intrerupere timer in ES:BX
          int  21h            ;Apelez interuperea DOS
          mov  time_old,bx    ;salvez adresa offset-ului interuperii vechi
          mov  time_old+2,es  ;si adresa de segment

          mov  dx,offset sunet_ti ;Adresa offset a noii rutine de temporizare
          mov  ax,251ch           ;Incarc adresa in TVI din DS:DX
          int  21h                ;Apelez interuperea DOS
          pop  bx                 ;Refac BX et DX de pe stiva
          pop  dx

          mov  al,0b6h         ;Pregatesc generare sunet (C2,LSB/MSB,mod3,binar)
          out  43h,al          ;incarc valoarea in registrul comanda timer
          xor  bh,bh           ;BH=0, offset pentru adresarea notei in tabel
          shl  bx,1            ;Dublez nr. notei (tabelul este pe cuvint)
          mov  ax,[note+bx]    ;Citesc valoarea notei
          
		  out  42h,al          ;Incarc octet low in Timer Counter Register (C2)
          mov  al,ah           
          out  42h,al          ;Incarc octet high in Timer Counter Register (C2)
          in   al,61h          ;Citesc bitii de control al dsifuzorului
          or   al,11b          ;Bitii B0 si B1 ai PIO (8255) activeaza difuzorul
          mov  end_s,1         ;Nota trebuie generata
          mov  nr_s,dl         ;Salvez durata notei
          out  61h,al          ;Activez difuzorul

play:     cmp  end_s,0         ;Nota gata ?
          jne  play            ;NU --> Astept
          in   al,61h          ;Citesc bitii de control difuzor
          and  al,11111100b    ;Anulez bitii B0,B1
          out  61h,al          ;Dezactivez difuzorul

;-- Activarea vechii intreruperi a timerului------------------------------
          mov cx,ds        		 ;Salvez  DS
          mov ax,251ch     		 ;Nr. functiei ptr.refacere vector in TVI
          lds dx,dword ptr time_old 	 ;Incarca vechea adresa in   DS:DX
          int 21h        	         ;Apelez interuperea DOS
          mov ds,cx        		 ;Refac DS
          pop  bx          		 ;Refac BX si DX de pe stiva
          pop  dx
          ret   	                 ;Revenire in program

play_nota endp

;-- Noua intrerupere a timer-ului --------------------------------
sunet_ti  proc far         		;Este apelata de 18 ori pe secunda
          dec  cs:nr_s    		;Decrementez numarator
          jne  end_st     		;Daca #0 sar, =0 gata
          mov  cs:end_s,0 		;Semnalez durata notei trecute
end_st:   iret			        ;revenire
sunet_ti  endp

;== Variabilele pentru rutine ============

time_old  dw (?),(?)    ; Vechea adresa de intrerupere a timer-ului
nr_s db (?)             ;Durata ramasa dintr-o nota in 1/18-imi de secunda
end_s    db (?)         ;Indica daca nota a fost generata

note      dw 4560,4304,4063,3834    ; constante de divizare ptr. notele din    
          dw 3619,3416,3224,3043    ; octava IV 
          dw 2873,2711,2559,2415    ; Do,Do#,Re,Re#,Mi,Fa,Sol,Sol#,La,La#,Si

;== End ================================================================
code      ends                         ;Sfirsit segment de COD
          end  sunet                   ;Sfirsit program 
;*--------------------------------------------------------------------*;